---
type: goal
acronym: modernCoding
isTemplate: true
author: 
    - sbe
    - fkr
title: Modern Coding Techniques
goalText: >
    Students should be introduced to current state-of-the-art coding techniques and general good practices of 
    a modern development team.
sources:
    - reference: [interview, fkr_interview, "Minute 00-04-29"]
    - reference: [interview, nnprof1_interview, "Minute 00-10-16"]
history:
    v1:
        date: 2021-07-02
        comment: initially created
    v2:
        date: 2021-07-02
        comment: added source and reference to sub-goals
todo: 
ignore:
    - w094
---

## Reasoning

For higher quality of teaching, a more realistic way of working for the students is useful. For this purpose
the experts interviewed listed various techniques that should be taught:

* Working with IDEs
* Versioning with GIT
* Project management with Jira/Kanban and others
* Formal notation of software

In addition, more advanced programming aspects are mentioned that should also be implemented:

* Building visual interfaces
* Integration of libraries
* Use of the debugger
* Modern practices like Test-Driven-Development